//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 PaleVioletRed
#property indicator_width1 2
#property indicator_level1 0

#import "libSSA.dll"
   void fastSingular(double& sourceArray[],int arraySize, int lag, int numberOfComputationLoops, double& destinationArray[]);
#import

//
//
//
//
//

extern string TimeFrame               = "Current time frame";
extern int    SSAPrice                =  PRICE_CLOSE;
extern int    SSALag                  = 20;
extern int    SSANumberOfComputations =  2;
extern int    SSAPeriodNormalization  = 20;
extern int    SSANumberOfBars         = 500;
extern string ForSymbol               = "";
extern bool   Interpolate             = true;
extern double alertsLevel = 0.25;
//
//
//
//
//

double in[];
double no[];
double ssaIn[];
double ssaOut[];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
      SetIndexBuffer(0,in);
      SetIndexBuffer(1,no);
      SetLevelValue(0, alertsLevel);
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(ForSymbol+" "+timeFrameToString(timeFrame)+" SSA normalized");
   if (ForSymbol=="") ForSymbol=Symbol();
   return(0);
}
int deinit(){return(0);}

//+--------------------------------------------------------------------------------------+
//|                                                                                      |
//+--------------------------------------------------------------------------------------+
//
//
//
//
//

int start()
{

   

   int i,limit,counted_bars = IndicatorCounted();

      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
      
   if (calculateValue || (ForSymbol==Symbol() && timeFrame == Period()))
   {
      int ssaBars = MathMin(Bars-1,SSANumberOfBars);
      for(i=limit; i>=0; i--)
      {
         double ma    = iMA(NULL,0,SSAPeriodNormalization,0,MODE_SMA,SSAPrice,i);
         double dev   = iStdDev(NULL,0,SSAPeriodNormalization,0,MODE_SMA,SSAPrice,i)*3.0;
         double price = iMA(NULL,0,1,0,MODE_SMA,SSAPrice,i);
                no[i] = (price-ma)/(MathMax(dev,0.000001));
      }
      
      //
      //
      //
      //
      //
      
         if (ArraySize(ssaIn) != ssaBars)
         {
            ArrayResize(ssaIn ,ssaBars);
            ArrayResize(ssaOut,ssaBars);
         }
         ArrayCopy(ssaIn,no,0,0,ssaBars);
                  fastSingular(ssaIn,ssaBars,SSALag,SSANumberOfComputations,ssaOut);
         ArrayCopy(in,ssaOut);
            
      return(0); 
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMin(Bars-1,SSANumberOfBars*timeFrame/Period());
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(ForSymbol,timeFrame,Time[i]);
         in[i] = iCustom(ForSymbol,timeFrame,indicatorFileName,"calculateValue",SSAPrice,SSALag,SSANumberOfComputations,SSAPeriodNormalization,SSANumberOfBars,0,y);

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(ForSymbol,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
            for(int k = 1; k < n; k++) in[i+k] = k*factor*in[i+n] + (1.0-k*factor)*in[i];
            
   }
            for(i =0; i<limit; i++){
            if(in[i]>alertsLevel )f0_2("up", i, clrBlue);
            if(in[i]<-alertsLevel)f0_2("dn", i, clrRed);
            }
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char1 = StringGetChar(s, length);
         if((char1 > 96 && char1 < 123) || (char1 > 223 && char1 < 256))
                     s = StringSetChar(s, length, char1 - 32);
         else if(char1 > -33 && char1 < 0)
                     s = StringSetChar(s, length, char1 + 224);
   }
   return(s);
}


void f0_2(string As_0, int Ai_8, color A_color_12) {
   string name_16 =  " " + As_0 + " " + TimeToStr(Time[Ai_8], TIME_DATE|TIME_MINUTES);
   ObjectCreate(name_16, OBJ_ARROW, 0, Time[Ai_8], 0);
   if (As_0 == "up") {
      ObjectSet(name_16, OBJPROP_ARROWCODE, 225);
      ObjectSet(name_16, OBJPROP_PRICE1, Low[Ai_8] - 5.0 * Point);
   }
   if (As_0 == "dn") {
      ObjectSet(name_16, OBJPROP_ARROWCODE, 226);
      ObjectSet(name_16, OBJPROP_PRICE1, High[Ai_8] + 5.0 * Point);
   }
   ObjectSet(name_16, OBJPROP_COLOR, A_color_12);
   ObjectSet(name_16, OBJPROP_WIDTH, 2);
}